#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0, max = 0;
    find_minmax({ 1, 2 }, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}
TEST_CASE("empty vector") {
    double min = 0, max = 0;
    CHECK(!find_minmax({}, min, max));
    
}

TEST_CASE("single element") {
    double min = 0, max = 0;
    find_minmax({ 5.5 }, min, max);
    CHECK(min == 5.5);
    CHECK(max == 5.5);
}

TEST_CASE("all negative") {
    double min = 0, max = 0;
    find_minmax({ -1, -5, -3 }, min, max);
    CHECK(min == -5);
    CHECK(max == -1);
}

TEST_CASE("all equal") {
    double min = 0, max = 0;
    find_minmax({ 7, 7, 7 }, min, max);
    CHECK(min == 7);
    CHECK(max == 7);
}
